comment ~

	This is just test code for DES routines.
	
	As example, to create lanman hash (Samba/Windows NT)
	It only creates 1 part of LM hash..
	But you can concatenate 2 of them together if you want ;-)

	============================ console paste

	C:\amd\des>des_test KGS!@#$% PASS

	Hex 64-bit key:5120546B31010101 Plaintext:4B47532140232425

	Ciphertext:B267DF22CB945E3E

	Deciphered Plaintext:4B47532140232425
	
	============================= end paste

	NOTE:if using 'PASSWORD' as key,
	the last D will be ommitted.. only 'PASSWOR' will be used.
	
	Why?

	DES uses a 56-bit key..(7 characters * 8 bits = 56)

	kernel_gaddafi - May/October 2005

~

.586				; needed for bswap
.model flat,stdcall

include <windows.inc>
include <kernel32.inc>
includelib <kernel32.lib>

include <\masm32\macros\macros.asm>

include <msvcrt.inc>
includelib <msvcrt.lib>

str_to_key PROTO C :DWORD,:DWORD
des_set_key PROTO C :DWORD, :DWORD
_des_encrypt PROTO C :DWORD,:DWORD,:DWORD

main proto :dword, :dword

DES_ENCRYPT        EQU   1
DES_DECRYPT        EQU   0

.data

include sbox.inc		; for des transform function..

stinfo              STARTUPINFO  <?>
bWildCard           DWORD  ?
pEnv                DWORD  ?
pArgv               DWORD  ?
nArgc               DWORD  ?

.code

start:
	;====================================

     mov	bWildCard, FALSE
     invoke crt___getmainargs,addr nArgc,addr pArgv,addr pEnv,[bWildCard],addr stinfo

     invoke main,nArgc,pArgv

     exit

main PROC   argc:DWORD, argv:DWORD

     LOCAL des_key      [8]       :BYTE
     LOCAL key_schedule [128]     :BYTE
     LOCAL password     [8]       :BYTE
     LOCAL plaintext    [8]       :BYTE
	
	mov	ebx, [argv]

	.IF (argc == 3)
						; zero initialise password/plaintext buffers.
            xor	eax, eax
            
            lea	edi, [password]
            stosd
            stosd

            lea	edi, [plaintext]
            stosd
            stosd

            ; get the plaintext
            ; copy no more than 8 bytes (64-bits)

            invoke crt_strncpy,addr plaintext,dword ptr [ebx + 4], 8

	    ; get the password/key
            ; copy no more than 7 bytes (56-bits)

            invoke crt_strncpy,addr password,dword ptr [ebx + 8], 7

            lea	esi, [plaintext]

            lodsd
            bswap    eax
            xchg  eax, edx

            lodsd
            bswap eax
            xchg  eax, ecx

            invoke str_to_key,addr password,addr des_key

            ; convert the password/key to 8-byte des odd parity key

            lea	esi, [des_key]
            lodsd
            bswap    eax

            xchg  eax, ebx
            lodsd
            bswap	eax

            invoke crt_printf,
                   chr$(10,'Hex 64-bit key:%08X%08X Plaintext:%08X%08X',10),
                   ebx,
                   eax,
                   edx,
                   ecx

            ; create 128 byte key schedule from des key

            invoke des_set_key,addr des_key,addr key_schedule

	    ; encrypt the plaintext

            invoke _des_encrypt,addr plaintext,addr key_schedule,DES_ENCRYPT

            lea	esi, [plaintext]
	    lodsd
	    bswap	eax
	    
            xchg	eax, ebx
	    lodsd
	    bswap	eax
	    invoke crt_printf,chr$(10,'Ciphertext:%08X%08X',10),ebx,eax

	    invoke _des_encrypt,addr plaintext,addr key_schedule,DES_DECRYPT

	    lea	esi, [plaintext]
	    lodsd
	    bswap	eax
	
            xchg	eax, ebx
	    lodsd
	    bswap	eax
	
            invoke crt_printf,chr$(10,'Deciphered Plaintext:%08X%08X',10),ebx,eax
	
	.ELSE
              invoke crt_printf,chr$(10,'DES Encryption Test',10,'Usage:%s <PLAINTEXT> <KEY>',10),dword ptr[ebx]
	.ENDIF
	ret
main ENDP

END start